const $ = require('jquery');
require("../css/payDetail.less");
require('./modal.js');
const {api} = require('./api.js')
const {post,getCookie,getUrlArgObjectNew,emptyBox} = require('./utils.js')
require('./../resource/jquery-ui/jquery-ui.min.js');
require('./../resource/jquery-ui/jquery-ui.min.css');
const iconCheck= require("./../images/icon_check.png")
const iconUnCheck = require("./../images/icon_unchecked.png")
const  iconCalenBlue= require("./../images/icon_calen_blue.png")
const  iconCalenGrey= require("./../images/icon_calen_grey.png")
const iconDown= require("./../images/arrow_down.png")
const iconUp = require("./../images/arrow_up.png")
const loadingImg = require("./../images/loading.gif")
const arrowLeft= require("./../images/arrow_left.png")
const arrowRight = require("./../images/arrow_right.png")

$(".selectLevel").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
$(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
let tabList = [], name = "", behospitalCode="", behosDateStart="", level="",behosDateEnd="", scoreSum = 0,statisticsType=2,
  nameTemp = "", behospitalCodeTemp="",levelTemp="", deptId="",deptIdTemp="", doctorName="", doctorNum="",doctorNameTemp="",doctorNumTemp="",
  data_desc=[],data_asc=[];
  let srcUrl = $("#contentIframe",parent.document).attr("src")
  statisticsType = getUrlArgObjectNew("dateType",srcUrl)||""
  
  if(statisticsType == 1){
      $(".monthYear .mon").css({
          backgroundColor:'#00A1FF',
          color:'#fff'
      }).siblings().css({
          color:'#00A1FF',
          backgroundColor:'#fff'
      })
  }else{
      $(".monthYear .year").css({
          backgroundColor:'#00A1FF',
          color:'#fff'
      }).siblings().css({
          color:'#00A1FF',
          backgroundColor:'#fff'
      })
  }
$(".abnormalClear").click(function(){
    behospitalCode=behospitalCodeTemp = ""
    $(".patientNumInp").val("")
    getTabData(1)
})
$(".partTitle a").click(function(){
    //初始菜单选中
    $(".menu .page",parent.document).removeClass("active").eq(0).addClass("active");
    $(".container",parent.document).addClass("console-cont");
})
$('.datapickerBox').append(`<img class="iconCalen" src=${iconCalenGrey} />`)
$('.iconCalen').on("mouseenter", function(e){
    $(this).attr("src", iconCalenBlue)
})
$('.iconCalen').on("mouseleave", function(e){
    $(this).attr("src", iconCalenGrey)
})
$('.iconCalen').on("click", function(e){
    $(this).parent().find("input").focus()
})
$('.recordScoreBtn').css("opacity",hasData('FUNC000017')?'1':'0.5')
dateChange()
//所有数据切换日期筛选
function dateChange(){
    $(".monthYear .mon").click(function(){
        $(this).css({
            backgroundColor:'#00A1FF',
            color:'#fff'
        }).siblings().css({
            color:'#00A1FF',
            backgroundColor:'#fff'
        })
        $(".dayDetail .deptListWrap").css("display","block")
        $(".dayDetail .dayFilter").css("display","none")
        statisticsType = 1
        getTabData(1)
    })
    $(".monthYear .year").click(function(){
        $(this).css({
            backgroundColor:'#00A1FF',
            color:'#fff'
        }).siblings().css({
            color:'#00A1FF',
            backgroundColor:'#fff'
        })
        $(".dayDetail .deptListWrap").css("display","none")
        $(".dayDetail .dayFilter").css("display","block")
        statisticsType = 2
        getTabData(1)
    })
}
//判断有无某一权限
  function hasData(data){
    let trdObj = JSON.parse(getCookie("trdObj"))
    let lis = trdObj['YH-BLZK-ZKPF']
    if(!lis){
      return false
    }
    if(lis.indexOf(data)>-1){//有权限
        return true
    }
    return false;
}
function getTabData(activePage){
    const param = {
        current:activePage,
        size: 15,
        name: behospitalCode||"",
        type: statisticsType||2, //1-本月，2-本年
        dateType: "",//(3-上月，4-去年本月，5-去年(必填))
    }
    post(api.getAverageFeePage,param).then(res =>{
        if(res.data.code == '0'){
            const data = res.data.data;
            tabList = data.records;
            const totalPage = data.pages;
            const totalNum = data.total;
            renderTab(tabList,data.hospitalId,activePage);
            renderPagination(totalPage,Number(activePage),totalNum)
            if(totalPage > 1){
                renderPagination(totalPage,Number(activePage),totalNum)
            } else{
                $('.pagination').html("")
            }
        }else{
            $.alerModal({"message":res.data.msg,type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        }
    }).catch((e) =>{
    
    })
}

getTabData(1)

$(".filter").on("click", function(e){
    name = nameTemp
    behospitalCode = behospitalCodeTemp
    level = levelTemp
    deptId = deptIdTemp
    getTabData(1)
})
function renderTab(data,hisId,activePage){
    let str = '',tmp = ''
    
    for(let i = 0; i < data.length; i++){
        const item = data[i]
        str += `
            <tr  data-index=${i}>
                <td  class="textCenter">${(activePage-1)*15 + i+1}</td>
                <td>${item.name || "-"}</td>
                <td >${item.averageValue}</td>
                <td >${item.lastAverageValue}</td>
                ${statisticsType==1?'<td>'+item.lastYearAverageValue+'</td>':''}
            </tr>
        `
    }
    let sts = `
        ${statisticsType==1?`<thead class="monType">
            <th class="moduleName" style="width: 65px;">序号</th>
            <th class="beHospitalId textCenter">科室名称</th>
            <th class="patientNo textCenter" >本月平均住院花费（元）</th>
            <th class="patientNo textCenter" >上月平均住院花费（元）</th>
            <th class="patientNo textCenter" >去年本月平均住院花费（元）</th>
        </thead>`:`
        <thead class="yearType">
            <th class="moduleName" style="width: 65px;">序号</th>
            <th class="beHospitalId textCenter">科室名称</th>
            <th class="patientNo textCenter" >本年平均住院花费（元）</th>
            <th class="patientNo textCenter" >去年平均住院花费（元）</th>
        </thead>
        `}
        <tbody>
            ${str?str:emptyBox()}
        </tbody>
    `
    $('.tableDay').html(sts)
    bindScoreDetail(hisId)
}

function scoreDetail(id,age,hid,code){
    window.open(`./qcScore.html?id=${id}&age=${age}&hid=${hid}&code=${code}`)
}
function bindScoreDetail(hisId){
    $('.patientNameSpan').on('click',function(e){
        const index = $(this).attr("data-index")
        const type = $(this).attr("data-type")
        const item = tabList[index]
        midifyMsgBox(item,type)
    })
}

  
function midifyMsgBox(item,type){
    const itemCopy = JSON.parse(JSON.stringify(item))
    let msgBox = ''
    if(type == 1){
        msgBox = `<div class="midifyMsgBox">
            <div class="mask"></div>
            <div class="midifyMsgContent abnormal">
                <p class="midifyMsgTitle">修改 <img class="iconClose" src=${require('./../images/icon_close_default.png')} alt="关闭" /></p>
                <div class="itemMsgInfoBox">
                    <span class="itemMsgLab abnormalLeft">状态：</span> 
                    <span class="abnormalAll" data-status="${itemCopy.status}">${itemCopy.status == 0?"未处理":"已处理"}</span>
                    <ul class="abnormalStatusLis">
                        <li data-status="0">未处理</li>
                        <li data-status="1">已处理</li>
                    </ul>
                </div>
                <div class="itemMsgInfoBox">
                    <span class="itemMsgLab abnormalLeft abnormalMark">备注：</span> 
                    <span class="itemInfoRight"> 
                        <textarea class="abnormalTxt" placeholder="请输入内容" >${itemCopy.remark}</textarea>
                    </span>
                </div>
                <div  class="itemMsgInfoTips">支持≥0的数字输入，最多保留小数点后1位~</div>
                <div class="midifyMsgBtn abnormalBtn">
                    <span class="midifyEdit">保存</span>
                </div>
            </div>
        </div>`
    }else{
        msgBox = `<div class="midifyMsgBox">
            <div class="mask"></div>
            <div class="midifyMsgContent midifyMsgContentDel">
                <p class="midifyMsgTitle">修改 <img class="iconClose" src=${require('./../images/icon_close_default.png')} alt="关闭" /></p>
                <p class="delTips">确认要删除该条异常记录？</p>
                <div class="midifyMsgBtn midifyMsgBtnDel">
                    <span class="midifyEdit midifyEditDel">删除</span>
                    <span class="midifyEdit midifyEditQuit">取消</span>
                </div>
            </div>
        </div>`
    }
    $("#mainBox", parent.document).append(msgBox)
    $(".midifyEditDel", parent.document).on("click",function(){
        delModifyOne(itemCopy)
    })
    $(".midifyEditQuit", parent.document).on("click",function(){
        $("#mainBox .midifyMsgBox", parent.document).remove()
    })
    $(".abnormalAll", parent.document).on("click",function(){
        $(".abnormalStatusLis", parent.document).slideToggle()
    })
    $(".abnormalStatusLis li", parent.document).on("click",function(){
        let status = $(this).attr("data-status")
        let str = $(this).html()
        $(".abnormalAll", parent.document).attr("data-status",status).html(str)
        $(".abnormalStatusLis", parent.document).slideToggle()
    })
    $("#mainBox .midifyMsgBox .iconClose", parent.document).on("click", function(e){
        $("#mainBox .midifyMsgBox", parent.document).remove()
    })
    $("#mainBox .midifyMsgBox .itemScore", parent.document).on("keypress", function(event){
        return (/[\d\.]/.test(String.fromCharCode(event.keyCode)))
     })
    $("#mainBox .midifyMsgBox .itemScore", parent.document).on("input", function(e){
       const val = $(this).val() 
       itemCopy.score = val
    })
    $("#mainBox .midifyMsgBox .midifyEdit", parent.document).on("click", function(e){
        saveModifyOne(itemCopy)
    })
}
//保存修改
function delModifyOne(itemCopy){
    let param = {
        "id": itemCopy.id
    }
    post(api.delQcAnnormal,param).then(res =>{
        if(res.data.code == '0'){
            const data = res.data.data;
            getTabData(1)
            $("#mainBox .midifyMsgBox", parent.document).remove()
            $.alerModal({"message":'删除成功',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        }else{
            
        }
    }).catch((e) =>{
    
    })
}
//保存修改
function saveModifyOne(itemCopy){
    let txt = $(".abnormalTxt", parent.document).val()
    let status = $(".abnormalAll", parent.document).attr("data-status")
    let param = {
        "id": itemCopy.id,
        "remark": txt,
        "status": status
    }
    post(api.saveQcAnnormal,param).then(res =>{
        if(res.data.code == '0'){
            const data = res.data.data;
            getTabData(1)
            $("#mainBox .midifyMsgBox", parent.document).remove()
            $.alerModal({"message":'修改成功',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        }else{
            
        }
    }).catch((e) =>{
    
    })
}
//选择病历等级
$('.selectLevel').on("click", function(e){
    e.stopPropagation()
    $(".deptList ").css("display", "none")
    $(".selectDept .arrow").attr("src",iconDown)
    const showList =  $(".levelList ").css("display")
    if(showList == "none" ||!showList){
        $(".levelList ").css("display","block")
        $(".selectLevel .arrow").attr("src",iconUp)
    }else{
        $(".levelList ").css("display", "none")
        $(".selectLevel .arrow").attr("src",iconDown)
    }
})

bindLeveldSelect()
//是否启用选择
function bindLeveldSelect(){
    $('.levelItem').on("click",function(){
        const levelItemName = $(this).attr("data-name")
        const levelItemItemId = $(this).attr("data-id")
        levelTemp =levelItemItemId
        $('.selectLevel').html(levelItemName)
        $(".levelList").css("display", "none")
        $(".selectLevel").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
    })
}

//全选绑定

$('.selectDept').on("click", function(e){
    e.stopPropagation()
    $(".levelList ").css("display","none")
    $(".selectLevel .arrow").attr("src",iconDown)
    const showList =  $(".deptList ").css("display")
    if(showList == "none" ||!showList){
        $(".deptList ").css("display","block")
        $(".selectDept .arrow").attr("src",iconUp)
    }else{
        $(".deptList ").css("display", "none")
        $(".selectDept .arrow").attr("src",iconDown)
    }
})


function rendeDeptList(deptList){
    let str = `<li class="deptItem " data-id=" " data-name="全部">全部</li>`
    for(let i = 0; i < deptList.length; i++){
        str += `<li class="deptItem ellipsis" title=${deptList[i].deptName} data-id=${deptList[i].deptId} data-name=${deptList[i].deptName}> ${deptList[i].deptName}</li>`
    }
    $('.deptList').html(str)
}
bindDeptSelect()
//科室选择
function bindDeptSelect(){
    $('.deptItem').on("click",function(){
        const deptItemName = $(this).attr("data-name")
        const deptItemId = $(this).attr("data-id")
        deptIdTemp =deptItemId
        if(deptItemName.length > 10){
            $('.selectDept').html(deptItemName.substring(0,8)+'...')
        }else{
            $('.selectDept').html(deptItemName)
        }
        $('.selectDept ').attr('title',deptItemName)
        $(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)

        $(".deptList").css("display", "none")
    })
}
function loading(){
    const str = `
    <div class="loadingBox">
            <div class="mask"></div>
            <img class="loadingImg" src=${loadingImg}  alt="loading" />
        </div>
    `
    $("#mainBox", parent.document).append(str)
}
function hideLoading(){
    $("#mainBox .loadingBox", parent.document).remove()
}
$('.recordScoreBtn').on("click",function(e){
    if(!hasData('FUNC000017')){
        return
    }
    let scoreList = []
    for(let i = 0; i <tabList.length; i++){
        if(tabList[i].hasSelect){
            scoreList.push(tabList[i].behospitalCode)
        }
    }
    if(scoreList.length === 0){
        $.alerModal({"message":'请选择要评分的项！',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        return
    } else{
        loading()
        for(let j = 0; j < scoreList.length; j++){
            recordScore(scoreList[j],scoreList.length)
        }
    }
})
$("th[code]").on("click",function(e){
    const code=$(this).attr("code");
    if(data_asc[0]===code){
      data_desc=[code];
      data_asc=[];
      $("th[code]").removeClass("asc desc");
      $(this).addClass("desc");
    }else{
      data_desc=[];
      data_asc=[code];
      $("th[code]").removeClass("asc desc");
      $(this).addClass("asc");
    }
    getTabData(1);
});
function recordScore(behospitalCode,totalNum){
    const param = {
        behospitalCode: behospitalCode
    }
    post(api.recordScore,param).then(res =>{
        if(res.data.code == '0'){
            scoreSum++
            if(scoreSum === totalNum){
                hideLoading()
                scoreSum = 0
                const activePage = $(".activePage").attr('data-page') || 1

                getTabData(activePage)
            }
      
        }else{}
    }).catch((e) =>{
    
    })
}
$(".patientNumInp").on("input", function(e){
    const val = $(this).val().trim()
    behospitalCodeTemp = val
})
$(".patientNameInp").on("input", function(e){
    const val = $(this).val().trim()
    nameTemp = val
})
$(".doctorInp").on("input", function(e){
    const val = $(this).val().trim()
    doctorNameTemp = val
})
$(".doctorNumInp").on("input", function(e){
  const val = $(this).val().trim();
    doctorNumTemp = val
})
$(function() {
    $.datepicker.regional['zh-CN'] = {
    clearText: '清除',
    clearStatus: '清除已选e799bee5baa6e59b9ee7ad9431333361303131日期',
    closeText: '关闭',
    closeStatus: '不改变当前选择',
    prevText: '<上月',
    prevStatus: '显示上月',
    prevBigText: '<<',
    prevBigStatus: '显示上一年',
    nextText: '下月>',
    nextStatus: '显示下月',
    nextBigText: '>>',
    nextBigStatus: '显示下一年',
    currentText: '今天',
    currentStatus: '显示本月',
    monthNames: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    monthNamesShort: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    yearNamesShort: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    monthStatus: '选择月份',
    yearStatus: '选择年份',
    weekHeader: '周',
    weekStatus: '年内周次',
    dayNames: ['星期日','星期一','星期二','星期三','星期四','星期五','星期六'],
    dayNamesShort: ['周日','周一','周二','周三','周四','周五','周六'],
    dayNamesMin: ['日','一','二','三','四','五','六'],
    dayStatus: '设置 DD 为一周起始',
    dateStatus: '选择 m月 d日, DD',
    dateFormat: 'yy-mm-dd',
    firstDay: 1,
    initStatus: '请选择日期',
    isRTL: false};
    $.datepicker.setDefaults($.datepicker.regional['zh-CN']);

    $( "#datepicker" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy/mm/dd"
    });
    $( "#datepicker2" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy/mm/dd"
    });
});

//分页渲染
function renderPagination(totalPage,activePage,totalNum){
    let str = `<span class="totalSum">共${totalPage}页/${totalNum}条数据</span><span class="prePage"><img class="arrowPage" src=${arrowLeft} /></span>`
    if(totalPage <= 6){
        for(let i = 1; i <= totalPage; i++){
          
            str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
        }
    }else{
        if(activePage <= 3){ //选中页数小于4
            for(let i = 1; i <= 4; i++){
                str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
            }
            str += `<span class="more" >...</span>`
        str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`

        } else if(activePage > totalPage -3){
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+(totalPage-3)}" data-page=${totalPage -3}>${totalPage -3}</span>`
            str += `<span class="pageNum ${'page'+(totalPage-2)}" data-page=${totalPage -2}>${totalPage -2}</span>`
            str += `<span class="pageNum ${'page'+(totalPage-1)}" data-page=${totalPage -1}>${totalPage -1}</span>`
            str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
        } else {
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+(activePage -1)}" data-page=${activePage -1}>${activePage -1}</span>`
            str += `<span class="pageNum ${'page'+activePage}" data-page=${activePage}>${activePage}</span>`
            str += `<span class="pageNum ${'page'+(activePage +1)}" data-page=${activePage +1}>${activePage +1}</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
        }
       
    }
    str += `<span class="nextPage"><img class="arrowPage" src=${arrowRight} /></span>`
    $('.pagination').html(str)
    $('.page' + activePage).addClass('activePage')
    $(".pageNum").on("click", function(e){
        const activePageNow = Number($(this).attr('data-page'))
        getTabData(activePageNow)
        // renderPagination(totalPage,activePageNow,totalNum)
    })
    $(".prePage").on("click", function(e){
        let activePageNow = Number($(".activePage").attr('data-page'))
        if(activePageNow > 1){
            activePageNow--
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    $(".nextPage").on("click", function(e){
        let activePageNow = Number($(".activePage").attr('data-page'))
        if(activePageNow < totalPage){
            activePageNow++
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    
}

$(document).on("click", function(){
    $(".levelList ").css("display", "none")
    $(".deptList").css("display", "none")
    $(".selectLevel .arrow").attr("src",iconDown)
    
})

$((function($){
})($));